package dev.fyloz.musicplayer.core.data.memory

import dev.fyloz.musicplayer.core.data.Repository

abstract class BaseMemoryRepository<T> : Repository<T> {
    protected val memoryCache = mutableMapOf<String, T>()

    override fun findAll() = memoryCache.values
    override fun findById(id: String) = memoryCache[id]
    override fun existsById(id: String) = findById(id) == true

    override fun save(t: T) {
        val id = getId(t)
        memoryCache[id] = t
    }

    override fun deleteById(id: String) {
        memoryCache.remove(id)
    }

    protected abstract fun getId(t: T): String;
}
