package dev.fyloz.musicplayer.modules.spotify.api

import kotlinx.serialization.SerialName
import kotlinx.serialization.Serializable

@Serializable
data class Track(
    val album: Album,
    val artists: Collection<Artist>,

    @SerialName("disc_number")
    val discNumber: Int,

    @SerialName("duration_ms")
    val durationMs: Long,
    val explicit: Boolean,

    @SerialName("external_ids")
    val externalIds: ExternalIds,

    @SerialName("external_urls")
    val externalUrls: ExternalUrls,
    val href: String,
    val id: String,

    @SerialName("is_local")
    val isLocal: Boolean,
    val name: String,
    val popularity: Int,

    @SerialName("preview_url")
    val previewUrl: String,

    @SerialName("track_number")
    val trackNumber: Int,
    val type: String,
    val uri: String
)
